<?php

namespace Teknisa\CRM\Controller;

use Teknisa\CRM\Controller\TeknisaCrud;
use \Zeedhi\Framework\DTO;
use \Zeedhi\Framework\DTO\Response\Error;
use \Zeedhi\Framework\DataSource\DataSet;
use \Zeedhi\Framework\DataSource\FilterCriteria;
use \Zeedhi\Framework\DataSource\Manager;
use \Zeedhi\Framework\DataSource\ParameterBag;

class ProdArvoreProdCrud extends TeknisaCrud{

	protected $dataSourceName = 'prodarvoreprod';
	protected $dataSourceManager;
	protected $parameterBagColumns = array();
	protected $messages;

	function __construct($crudService, $parameterBag, $dataSourceManager){
		$this->dataSourceManager = $dataSourceManager;
		parent::__construct($crudService, $parameterBag);
	}

	public function save(DTO\Request $request, DTO\Response $response){

		$row = $request->getRow();
		if($row['__is_new']){
			$condition = array(
				array(
					"columnName" => "CDPRODUTO",
					"operator" => "=",
					"value" => $row["CDPRODUTO"]
				),
				array(
					"columnName" => "NRTPARVPROD",
					"operator" => "=",
					"value" => $row["NRTPARVPROD"]
				)
			);

			$filterCriteria = new FilterCriteria($this->dataSourceName, $condition);
      $dataSet = $this->dataSourceManager->findBy($filterCriteria);
      $registrosEncontrados = $dataSet->getRows();

      if(empty($registrosEncontrados)){
          parent::save($request, $response);
      } else {
          $response->setError(new DTO\Response\Error($this->messages->getMessage('APP-00002'), 1));
      }
    } else {
      parent::save($request, $response);
    }

	}
}