<?php
namespace Teknisa\CRM\Controller;

use Teknisa\CRM\Controller\TeknisaCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DTO\Response;

class crmHorarioAtendimentoController extends TeknisaCrud {
    
    protected $dataSourceName = 'crm_horatrab';
    
    protected $entityManager;
    protected $connection;
    protected $newCode;
    protected $environment;

    public function __construct ($crudService, $parameterBag, $entityManager, $newCode, $environment)
    {
        $this->entityManager = $entityManager;
        $this->newCode       = $newCode;
        $this->connection    = $entityManager->getConnection();
        $this->environment   = $environment;

        parent::__construct($crudService, $parameterBag);
    }
    
     public function save(DTO\Request $request, DTO\Response $response){
         
          foreach($request->getDataSet()->getRows() as $row){
             
            if (isset($row['changed_NMHORARIO'])){
                $row["NMHORARIO"] = $row["NMHORARIO_inline"];
            };  
            
            if (isset($row['changed_SEGUNDAGRID'])){
                if(!empty($row["HRINI2SEGUNDA"])){
                    $SEGUNDA = explode(' às ',$row["changed_SEGUNDAGRID"]);
                    $SEGUNDAINI = $SEGUNDA[0];
                    $SEGUNDAFIN = $SEGUNDA[1];
                    $row["HRINI1SEGUNDA"] = $SEGUNDAINI;
                    $row["HRFIN2SEGUNDA"] = $SEGUNDAFIN;
                    $row["IDABERTO_SEGUNDA"]    = 'S';
                }else{
                    $SEGUNDA = explode(' às ',$row["changed_SEGUNDAGRID"]);
                    $SEGUNDAINI = $SEGUNDA[0];
                    $SEGUNDAFIN = $SEGUNDA[1];
                    $row["HRINI1SEGUNDA"] = $SEGUNDAINI;
                    $row["HRFIN1SEGUNDA"] = $SEGUNDAFIN;
                    $row["HRFIN2SEGUNDA"] = $SEGUNDAFIN;
                    $row["IDABERTO_SEGUNDA"]    = 'S';
                }
            };
            if (isset($row['changed_TERCAGRID'])){
                if(!empty($row["HRINI2TERCA"])){
                    $TERCA = explode(' às ',$row["changed_TERCAGRID"]);
                    $TERCAINI = $TERCA[0];
                    $TERCAFIN = $TERCA[1];
                    $row["HRINI1TERCA"] = $TERCAINI;
                    $row["HRFIN2SEGUNDA"] = $TERCAFIN;
                    $row["IDABERTO_TERCA"]    = 'S';
            }else{
                 $TERCA = explode(' às ',$row["changed_TERCAGRID"]);
                $TERCAINI = $TERCA[0];
                $TERCAFIN = $TERCA[1];
                $row["HRINI1TERCA"] = $TERCAINI;
                $row["HRFIN1SEGUNDA"] = $TERCAFIN;
                $row["HRFIN2SEGUNDA"] = $TERCAFIN;
                $row["IDABERTO_TERCA"]    = 'S';
                }
            };
            if (isset($row['changed_QUARTAGRID'])){
                if(!empty($row["HRINI2QUARTA"])){
                    $QUARTA = explode(' às ',$row["changed_QUARTAGRID"]);
                    $QUARTAINI = $QUARTA[0];
                    $QUARTAFIN = $QUARTA[1];
                    $row["HRINI1QUARTA"] = $QUARTAINI;
                    $row["HRFIN2QUARTA"] = $QUARTAFIN;
                    $row["IDABERTO_QUARTA"]    = 'S';
                }else{
                    $QUARTA = explode(' às ',$row["changed_QUARTAGRID"]);
                    $QUARTAINI = $QUARTA[0];
                    $QUARTAFIN = $QUARTA[1];
                    $row["HRINI1QUARTA"] = $QUARTAINI;
                    $row["HRFIN1QUARTA"] = $QUARTAFIN;
                    $row["HRFIN2QUARTA"] = $QUARTAFIN;
                    $row["IDABERTO_QUARTA"]    = 'S'; 
                }
             };
            if (isset($row['changed_QUINTAGRID'])){
                 if(!empty($row["HRINI2QUINTA"])){
                    $QUINTA = explode(' às ',$row["changed_QUINTAGRID"]);
                    $QUINTAINI = $QUINTA[0];
                    $QUINTAFIN = $QUINTA[1];
                    $row["HRINI1QUINTA"] = $QUINTAINI;
                    $row["HRFIN2QUINTA"] = $QUINTAFIN;
                    $row["IDABERTO_QUINTA"]    = 'S';
                 }else{
                    $QUINTA = explode(' às ',$row["changed_QUINTAGRID"]);
                    $QUINTAINI = $QUINTA[0];
                    $QUINTAFIN = $QUINTA[1];
                    $row["HRINI1QUINTA"] = $QUINTAINI;
                    $row["HRFIN1QUINTA"] = $QUINTAFIN;
                    $row["HRFIN2QUINTA"] = $QUINTAFIN;
                    $row["IDABERTO_QUINTA"]    = 'S';
                 }
             };
            if (isset($row['changed_SEXTAGRID'])){
                if(!empty($row["HRINI2SEXTA"])){
                    $SEXTA = explode(' às ',$row["changed_SEXTAGRID"]);
                    $SEXTAINI = $SEXTA[0];
                    $SEXTAFIN = $SEXTA[1];
                    $row["HRINI1SEXTA"] = $SEXTAINI;
                    $row["HRFIN2SEXTA"] = $SEXTAFIN;
                    $row["IDABERTO_SEXTA"]    = 'S';
                }else{
                    $SEXTA = explode(' às ',$row["changed_SEXTAGRID"]);
                    $SEXTAINI = $SEXTA[0];
                    $SEXTAFIN = $SEXTA[1];
                    $row["HRINI1SEXTA"] = $SEXTAINI;
                    $row["HRFIN1SEXTA"] = $SEXTAFIN;
                    $row["HRFIN2SEXTA"] = $SEXTAFIN;
                    $row["IDABERTO_SEXTA"]    = 'S';
                }
             };
            if (isset($row['changed_SABADOGRID'])){
               if(!empty($row["HRINI2SABADO"])){  
                    $SABADO = explode(' às ',$row["changed_SABADOGRID"]);
                    $SABADOINI = $SABADO[0];
                    $SABADOFIN = $SABADO[1];
                    $row["HRINI1SABADO"] = $SABADOINI;
                    $row["HRFIN2SABADO"] = $SABADOFIN;
                    $row["IDABERTO_SABADO"]    = 'S';
               }else{
                    $SABADO = explode(' às ',$row["changed_SABADOGRID"]);
                    $SABADOINI = $SABADO[0];
                    $SABADOFIN = $SABADO[1];
                    $row["HRINI1SABADO"] = $SABADOINI;
                    $row["HRFIN1SABADO"] = $SABADOFIN;
                    $row["HRFIN2SABADO"] = $SABADOFIN;
                    $row["IDABERTO_SABADO"]    = 'S';
               }
             };
            if (isset($row['changed_DOMINGOGRID'])){ 
               if(!empty($row["HRINI2DOMINGO"])){ 
                    $DOMINGO = explode(' às ',$row["changed_DOMINGOGRID"]);
                    $DOMINGOINI = $DOMINGO[0];
                    $DOMINGOFIN = $DOMINGO[1];
                    $row["HRINI1DOMINGO"] = $DOMINGOINI;
                    $row["HRFIN2DOMINGO"] = $DOMINGOFIN;
                    $row["IDABERTO_DOMINGO"]    = 'S';
               }else{
                    $DOMINGO = explode(' às ',$row["changed_DOMINGOGRID"]);
                    $DOMINGOINI = $DOMINGO[0];
                    $DOMINGOFIN = $DOMINGO[1];
                    $row["HRINI1DOMINGO"] = $DOMINGOINI;
                    $row["HRFIN1DOMINGO"] = $DOMINGOFIN;
                    $row["HRFIN2DOMINGO"] = $DOMINGOFIN;
                    $row["IDABERTO_DOMINGO"]     = 'S';
               }
            };
       
        $update = "UPDATE CRM_HORATRAB
                    SET NMHORARIO           =   :NMHORARIO,
                        HRINI1SEGUNDA       =   :HRINI1SEGUNDA,
                        HRFIN1SEGUNDA       =   :HRFIN1SEGUNDA,
                        HRFIN2SEGUNDA       =   :HRFIN2SEGUNDA,
                        HRINI1TERCA         =   :HRINI1TERCA,
                        HRFIN1TERCA         =   :HRFIN1TERCA,
                        HRINI1QUARTA        =   :HRINI1QUARTA,
                        HRFIN1QUARTA        =   :HRFIN1QUARTA,
                        HRINI1QUINTA        =   :HRINI1QUINTA,
                        HRFIN1QUINTA        =   :HRFIN1QUINTA,
                        HRINI1SEXTA         =   :HRINI1SEXTA,
                        HRFIN1SEXTA         =   :HRFIN1SEXTA,
                        HRINI1SABADO        =   :HRINI1SABADO,
                        HRFIN1SABADO        =   :HRFIN1SABADO,
                        HRINI1DOMINGO       =   :HRINI1DOMINGO,
                        HRFIN1DOMINGO       =   :HRFIN1DOMINGO,
                        IDABERTO_SEGUNDA    =   :IDABERTO_SEGUNDA, 
                        IDABERTO_TERCA      =   :IDABERTO_TERCA, 
                        IDABERTO_QUARTA     =   :IDABERTO_QUARTA, 
                        IDABERTO_QUINTA     =   :IDABERTO_QUINTA, 
                        IDABERTO_SEXTA      =   :IDABERTO_SEXTA, 
                        IDABERTO_SABADO     =   :IDABERTO_SABADO, 
                        IDABERTO_DOMINGO    =   :IDABERTO_DOMINGO 
                    WHERE NRHORATRAB = :NRHORATRAB 
                           AND NRORG = :NRORG";

        $params = array
        (
            "NMHORARIO"             => $row["NMHORARIO"],
            "NRHORATRAB"            => $row["NRHORATRAB"],
            "NRORG"                 => $row["NRORG"],
            "HRINI1SEGUNDA"         => $row["HRINI1SEGUNDA"],
            "HRFIN1SEGUNDA"         => $row["HRFIN1SEGUNDA"],
            "HRFIN2SEGUNDA"         => $row["HRFIN2SEGUNDA"],
            "HRINI1TERCA"           => $row["HRINI1TERCA"],
            "HRFIN1TERCA"           => $row["HRFIN1TERCA"],
            "HRINI1QUARTA"          => $row["HRINI1QUARTA"],
            "HRFIN1QUARTA"          => $row["HRFIN1QUARTA"],
            "HRINI1QUINTA"          => $row["HRINI1QUINTA"],
            "HRFIN1QUINTA"          => $row["HRFIN1QUINTA"],
            "HRINI1SEXTA"           => $row["HRINI1SEXTA"],
            "HRFIN1SEXTA"           => $row["HRFIN1SEXTA"],
            "HRINI1SABADO"          => $row["HRINI1SABADO"],
            "HRFIN1SABADO"          => $row["HRFIN1SABADO"],
            "HRINI1DOMINGO"         => $row["HRINI1DOMINGO"],
            "HRFIN1DOMINGO"         => $row["HRFIN1DOMINGO"],
            "IDABERTO_SEGUNDA"      => $row["IDABERTO_SEGUNDA"],
            "IDABERTO_TERCA"        => $row["IDABERTO_TERCA"],
            "IDABERTO_QUARTA"       => $row["IDABERTO_QUARTA"],
            "IDABERTO_QUINTA"       => $row["IDABERTO_QUINTA"],
            "IDABERTO_SEXTA"        => $row["IDABERTO_SEXTA"],
            "IDABERTO_SABADO"       => $row["IDABERTO_SABADO"],
            "IDABERTO_DOMINGO"      => $row["IDABERTO_DOMINGO"]
        );

        $std = $this->entityManager->getConnection()->prepare($update);
        $std->execute($params);
 
          }
         
     }
}
?>