function TermometroOportunidadeController(General, templateManager, CRM_Utilities, ScreenService, ZhFilterPreferences) {

    this.setHexColorCodeInCurrentRow = function(widget){
        var currentRow = widget.currentRow;
        currentRow.DSCORHEXADECIMAL = currentRow.DSCORHEXADECIMAL.toHexString();
    };
    
    this.setColor = function(row, element, widget){
        if(widget!=='Active')
            widget = templateManager.container.getWidget(widget);
        else
            widget = templateManager.container.getActiveWidget();
        var field = widget.getField("DSCORHEXADECIMAL");
        if(widget.mode != "edit"){
            element.children('p').remove();
            element.children('span').remove();
            element.children('div').remove();
            var class1 = "colorfield", class2 = "zh-field-value";
            if(widget.mode == "view"){
                class1 += " colorfield-in-form";
            }
            else {
                class1 += " colorfield-in-grid";
            }
            element.append('<div class='+class2+'> <div class='+class1+' style = background-color:'+ row.DSCORHEXADECIMAL +';"> </div> </div>');
        }
    };
    
    this.widgetSave = function(widget){
        CRM_Utilities.setColumnToReturnInCurrentRow(widget.currentRow, 'NRTERMOPORTUNI');
        General.widgetSave(widget).then(function(response){
            widget.currentRow.NRTERMOPORTUNI = response.dataset.columnsToReturn[0].NRTERMOPORTUNI;
            if(widget.mode === "list")
                widget.reload();
        });
    };
    
    this.openOportWindowFilteringOper = function(widget){
        ScreenService.openWindow('product#crm00002_001_oportunidade_de_negocio').then(function(){
            
            var oportWidgt = templateManager.container.getWidget('oportunidadegrid');
            
            oportWidgt.dataSourceFilter = [
                {
                    name: "NRORG",
                    operator: "=",
                    value: "@templateManager.LOGGEDOPERATOR.NRORG@"
                },
                {
                    name: "IDTPOPERADOR",
                    operator: "=",
                    value: "E"
                },
                {
                    name: "NRPARCRESP",
                    operator: "=",
                    default: true,
                    value: widget.currentRow.NRPARCNEGOCIO
                },
                {
                    name: "SITUACAO",
                    operator: "IN",
                    static: true,
                    value: "@['A']@"
                }
            ];
            oportWidgt.reload().then(function(){
                ScreenService.closePopup(true);
                oportWidgt.actions.forEach(function(action, index){
                    if(action.name == 'BACK_CHARTS')
                        action.isVisible = true;
                });
                oportWidgt.activate();
                oportWidgt.TERMFILTER = true;
                oportWidgt.__filterPopup.currentRow.CDOPERADOR = [widget.currentRow.CDOPERADOR];
                oportWidgt.__filterPopup.currentRow.NRPARCRESP = [widget.currentRow.NRPARCNEGOCIO];
                oportWidgt.__filterPopup.currentRow.NMPARCRESP = [widget.currentRow.OPERADOR];
                oportWidgt.__filterPopup.getField('NRPARCRESP').reload();
            });
            
            
            
        });
        
        this.checkTermFilter = function(widget){
            if(widget.TERMFILTER){
                ZhFilterPreferences.openFilterWidget(widget);
                widget.TERMFILTER = false;
                widget.actions.forEach(function(action, index){
                if(action.name == 'BACK_CHARTS')
                    action.isVisible = false;
                });
            }
        };
    };
}
Configuration(function(ContextRegister) {
    ContextRegister.register('TermometroOportunidadeController', TermometroOportunidadeController);
});